/*
 * Swagger Basket
 *
 * Корзина товаров
 *
 * The version of the OpenAPI document: 1.0.0
 *
 * Generated by: https://openapi-generator.tech
 */

using System.Runtime.Serialization;
using System.Text;
using Newtonsoft.Json;

namespace BasketApp.Api.Adapters.Http.Contract.src.OpenApi.Models;

/// <summary>
/// </summary>
[DataContract]
public class Good : IEquatable<Good>
{
    /// <summary>
    ///     Идентификатор
    /// </summary>
    /// <value>Идентификатор</value>
    [DataMember(Name = "id", EmitDefaultValue = true)]
    public Guid Id { get; set; }

    /// <summary>
    ///     Название
    /// </summary>
    /// <value>Название</value>
    [DataMember(Name = "title", EmitDefaultValue = false)]
    public string Title { get; set; }

    /// <summary>
    ///     Описание
    /// </summary>
    /// <value>Описание</value>
    [DataMember(Name = "description", EmitDefaultValue = false)]
    public string Description { get; set; }

    /// <summary>
    ///     Цена
    /// </summary>
    /// <value>Цена</value>
    [DataMember(Name = "price", EmitDefaultValue = true)]
    public decimal Price { get; set; }

    /// <summary>
    ///     Количество (остатки)
    /// </summary>
    /// <value>Количество (остатки)</value>
    [DataMember(Name = "quantity", EmitDefaultValue = true)]
    public int Quantity { get; set; }

    /// <summary>
    ///     Вес
    /// </summary>
    /// <value>Вес</value>
    [DataMember(Name = "weight", EmitDefaultValue = true)]
    public int Weight { get; set; }

    /// <summary>
    ///     Returns true if Good instances are equal
    /// </summary>
    /// <param name="other">Instance of Good to be compared</param>
    /// <returns>Boolean</returns>
    public bool Equals(Good other)
    {
        if (other is null) return false;
        if (ReferenceEquals(this, other)) return true;

        return
            (
                Id == other.Id ||
                Id.Equals(other.Id)
            ) &&
            (
                Title == other.Title ||
                (Title != null &&
                 Title.Equals(other.Title))
            ) &&
            (
                Description == other.Description ||
                (Description != null &&
                 Description.Equals(other.Description))
            ) &&
            (
                Price == other.Price ||
                Price.Equals(other.Price)
            ) &&
            (
                Quantity == other.Quantity ||
                Quantity.Equals(other.Quantity)
            ) &&
            (
                Weight == other.Weight ||
                Weight.Equals(other.Weight)
            );
    }

    /// <summary>
    ///     Returns the string presentation of the object
    /// </summary>
    /// <returns>String presentation of the object</returns>
    public override string ToString()
    {
        var sb = new StringBuilder();
        sb.Append("class Good {\n");
        sb.Append("  Id: ").Append(Id).Append("\n");
        sb.Append("  Title: ").Append(Title).Append("\n");
        sb.Append("  Description: ").Append(Description).Append("\n");
        sb.Append("  Price: ").Append(Price).Append("\n");
        sb.Append("  Quantity: ").Append(Quantity).Append("\n");
        sb.Append("  Weight: ").Append(Weight).Append("\n");
        sb.Append("}\n");
        return sb.ToString();
    }

    /// <summary>
    ///     Returns the JSON string presentation of the object
    /// </summary>
    /// <returns>JSON string presentation of the object</returns>
    public string ToJson()
    {
        return JsonConvert.SerializeObject(this, Formatting.Indented);
    }

    /// <summary>
    ///     Returns true if objects are equal
    /// </summary>
    /// <param name="obj">Object to be compared</param>
    /// <returns>Boolean</returns>
    public override bool Equals(object obj)
    {
        if (obj is null) return false;
        if (ReferenceEquals(this, obj)) return true;
        return obj.GetType() == GetType() && Equals((Good)obj);
    }

    /// <summary>
    ///     Gets the hash code
    /// </summary>
    /// <returns>Hash code</returns>
    public override int GetHashCode()
    {
        unchecked // Overflow is fine, just wrap
        {
            var hashCode = 41;
            // Suitable nullity checks etc, of course :)

            hashCode = hashCode * 59 + Id.GetHashCode();
            if (Title != null)
                hashCode = hashCode * 59 + Title.GetHashCode();
            if (Description != null)
                hashCode = hashCode * 59 + Description.GetHashCode();

            hashCode = hashCode * 59 + Price.GetHashCode();

            hashCode = hashCode * 59 + Quantity.GetHashCode();

            hashCode = hashCode * 59 + Weight.GetHashCode();
            return hashCode;
        }
    }

    #region Operators

#pragma warning disable 1591

    public static bool operator ==(Good left, Good right)
    {
        return Equals(left, right);
    }

    public static bool operator !=(Good left, Good right)
    {
        return !Equals(left, right);
    }

#pragma warning restore 1591

    #endregion Operators
}